<id>
Random Quotes for YaBB 2.3
</id>

<version>
1.1
</version>

<mod info>
This mod gives you two new tags that produce random quotes in the language of the poster, or the member.
For in the main template there is the tag {yabb tagline}, and for the signature and posts there is the UBBC tag [tagline].
Note: In the old YaBB 2.1 style template, you need to use <yabb tagline> instead of {yabb tagline}

Usage
Add the appropriate tag where you want it to be displayed and depending on your language settings it will produce random quotes in the correct language.
You can add or delete quotes as you like, but the number in taglines.dat must be set to the same number of qoutes in taglines.txt.

Installation
Modify YaBB files using BoardMod or manually. 
Upload modified files to your server. 
Upload the taglines.txt and taglines.dat to the appropriate language directory and chmod equal to other lng files.

Files to edit
Admin/Modlist.pl
Sources/Display.pl
Sources/Printpage.pl
Sources/Profile.pl
Sources/Subs.pl
Sources/YaBBC.pl

Restrictions and Short comings
There is no admin section to edit/add taglines. 
The taglines.txt is a flatfile plain ascii file holding one tagline per line. 
The taglines.dat holds one variable which must be set manually to the number of lines found in the taglines.txt, and it holds the text in front of the quote.
For each language you should have a set of these files, but if no files are found or the user has no language set the taglines will default to the board language set.

Version History
1.0 - First release by Spikecity for YabBB 2.1 - 12th February 2007
1.1 - Updated for YaBB 2.3 by Derek Barnstorm - 16th November 2008

</mod info>

<author>
Original code by Spikecity / Updated by Derek Barnstorm
</author>

<homepage>
http://www.boardmod.org
</homepage>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$rquote = "Random Quotes 1.1|Original code by Spikecity / Updated by Derek Barnstorm|Allows language dependent random quotes in tags and sigs|1.1|16th November 2008";
	push (@installed_mods, "$rquote");
</add before>

<edit file>
Sources/Display.pl
</edit file>

<search for>
		# Do we have an attachment file?
</search for>

<add before>

		$taglineuser = $musername || $username;

</add before>

<edit file>
Sources/Printpage.pl
</edit file>

<search for>
	$threadpost =~ s~\[move\](.*?)\[/move\]~$1~isg;
</search for>

<add after>

    ## insert random quote in place of the tagline ##
	$threadpost =~ s~\[tagline\]~&random_quote($taglineuser)~eisg;
</add after>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
	if (${$uid.$user}{'signature'}) {
</search for>

<add after>
		$taglineuser = $user;
</add after>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
if (-e ("AdminIndex.cgi")) { $yyaext = "cgi"; }
else { $yyaext = "pl"; }
</search for>

<add after>

sub random_quote {
	my $user = $_[0];
	my $use_lang     = ${$uid.$user}{'language'} || $lang;
	my ($count,$tagline, $outlang);
	if (-e "$langdir/$use_lang/taglines.dat") {
		$outlang = "$langdir/$use_lang";
	} elsif (-e "$langdir/$lang/taglines.dat") {
		$outlang = "$langdir/$lang";
	} elsif (-e "$langdir/English/taglines.dat") {
		$outlang = "$langdir/English";
	} else {
		&fatal_error("tagline file not found");
	}
	require "$outlang/taglines.dat";
	my $record = int(rand ($maxtags));
	fopen (TAGS, "$outlang/taglines.txt");
	while ($tagline = <TAGS>) {
		chomp $tagline;
		last if ($count eq $record);
		$count++;
	}
	fclose (TAGS);
	return "$tagtext$tagline";
}

</add after>

<search for>
	$yyposition      = $yytitle;
	$yytitle         = "$mbname - $yytitle";
</search for>

<add after>
	## Generate the template random quote tag ##
	$yytagline = &random_quote($username);
</add after>

<edit file>
Sources/YaBBC.pl
</edit file>

<search for>
	$message =~ s~\[move\](.*?)\[/move\]~<marquee>$1</marquee>~isg;
</search for>

<add after>

    ## insert random quote in place of the tagline ##
	$message =~ s~\[tagline\]~&random_quote($taglineuser)~eisg;
</add after>
